// cell game
int [][] cell;
int [][] next;
// 1つのセルのサイズを定義する
int cellWidth = 8;
int cellHeight = 8;
// それぞれ縦横何マス敷き詰めるか
int numCellX, numCellY;
int [] arrayAlive;

void setup() {
  // 800x800のウインドウを作成する
  size( 800, 800 );

  // フォントを多少大きくする
  textSize( 32 );

  // 縦横のウインドウサイズから何マスずつ埋めることができるかを計算する
  numCellX = width/cellWidth;
  numCellY = height/cellHeight;

  initLifegame();
  // 1秒辺り10回描画する（drawを10回呼び出す）
  frameRate(10);
}

void draw() {
  // ここからライフゲームの1回の生死に関する処理を書く
  for ( int x=1; x<=numCellX; x++ ) {
    for ( int y=1; y<=numCellY; y++ ) {
      next[x][y] = checkNextDeadOrAlive( x, y );
    }
  }

  for ( int x=0; x<numCellX+2; x++ ) {
    for ( int y=0; y<numCellY+2; y++ ) {
      cell[x][y] = next[x][y];
    }
  }

  // 背景を黒色で塗りつぶす
  background( 0 );
  // 線の色は黒色に設定
  stroke( 0 );

  // ここからライフゲームの描画に関する処理を書く
  drawLifegame();

  // グラフを表示する
  drawGraph();
}

void mousePressed() 
{
  // クリックされたセルの場所を特定する
  // 配列では 1 から numCellX まで
  // 配列では 1 から numCellY まで
  int targetCellX = (int)(mouseX/cellWidth);
  int targetCellY = (int)(mouseY/cellHeight);

  // クリックされたセルは生の状態に変更する
  cell[targetCellX+1][targetCellY+1] = 1;
}

// ライフゲームの初期化をする関数
void initLifegame() {
  // 生の数をグラフとして表示するため用意
  arrayAlive = new int [width];

  // マス目に応じて配列を用意する
  // tempは一時的に計算結果を格納する配列
  // ただしx==0, y==0, x==numCellX+1, y==numCellY+1は非表示のものとする
  // 1からnumCellXまで，1からnumCellYまでを表示領域とする
  cell = new int [numCellX+2][numCellY+2];
  next = new int [numCellX+2][numCellY+2];

  // グラフ表示用の配列を初期化
  arrayAlive = new int [width];
  for ( int i=0; i<width; i++ ) {
    arrayAlive[i] = 0;
  }

  // 繰り返しで初期化をする
  // 2個中1個のセルは生の状態にする
  for( int x=0; x<numCellX+2; x++ ){
    for( int y=0; y<numCellY+2; y++ ){
      if ( x == 0 || x == numCellX+1 || y == 0 || y == numCellY+1 ) {
        // 端はすべて0とする
        cell[x][y] = 0;
      } else {
        // 2個中1個は生の状態にする
        // ここの値の与え方で初期状態でどの程度生の状態にするかを決める
        cell[x][y] = (int)random(2);
      }
    }
  }
}

// 指定したセルの次のターンの生死を取得する
int checkNextDeadOrAlive( int x, int y ) {
  // ここを完成させる
  // cellの配列を利用する



}

// ライフゲームを描画する関数
void drawLifegame() {
  for ( int x=1; x<=numCellX; x++ ) {
    for ( int y=1; y<=numCellY; y++ ) {
      if ( cell[x][y] == 1 ) {
        fill( 0, 255, 0 );
      } else {
        fill( 0, 0, 0 );
      }
      rect( (x-1)*cellWidth, (y-1)*cellHeight, cellWidth, cellHeight );
    }
  }
}

// 生の数を数える関数
int getCountOfAlive() {
  int _numOfAlive = 0;

  // ここを完成させる
  for ( int x=1; x<=numCellX; x++ ) {
    for ( int y=1; y<=numCellY; y++ ) {
      if ( cell[x][y] == 1 ) {
        _numOfAlive++;
      }
    }
  }
  return _numOfAlive;
}

// 生の数をグラフ描画する関数
void drawGraph() {
  // 値をシフトして現在の生の値を最初に放り込む
  for ( int i=width-2; i>=0; i-- ) {
    arrayAlive[i+1] = arrayAlive[i];
  }
  arrayAlive[0] = getCountOfAlive();

  // 画面下部に10分の1したグラフを表示する
  stroke( 255 );
  for ( int i=0; i<width-1; i++ ) {
    line( i, height-arrayAlive[i]/10, i+1, height-arrayAlive[i+1]/10 );
  }
}
